Subject: Re: bug#42824: 26.3; Feature request: implement 'smooth scroll' in djvu.el package

From: dalanicolai <[email-masked]>
Date: Mon, 16 Nov 2020 14:08:08 +0100

The scrolling functionality looks great now. Indeed setting the
djvu-continuous to t provides the functionality that I requested/proposed.

Regarding the annotation features, I have implemented more in djvu2.el than
just highlighting rectangles. It also shows free text, line and arrow
annotations. I think those things can not be implemented via
`djvu-image-rect`. The djvu2.el page contains a demo screencast
<https://github.com/dalanicolai/djvu2.el#usage>. Just to remind you,
djvu2.el also implements djvu-occur and imenu functionality.

Regarding tooltips based on pixel coordinates, this can be achieved (as it
has been done in pdf-tools) via the `:map` and `:pointer` keywords in the image
descriptor
<https://www.gnu.org/software/emacs/manual/html_node/elisp/Image-Descriptors.html>.
However instead of implementing this separately, I think it would be great
if as much as possible of the pdf-tools code could be reused (I mean that
djvu and pdf share as much code as possible for similar functionality).
Although it would be great if it got implemented, so that Emacs also
becomes the best document reader, for me personally the invested time would
not be worth the gain (Although I might have a look at it some time as some
kind of exercise. djvu2.el for me was also just an exercise/study).
<https://www.gnu.org/software/emacs/manual/html_node/elisp/Image-Descriptors.html>

On Sun, 15 Nov 2020 at 22:18, Roland Winkler <[email-masked]> wrote:

> On Sat Nov 7 2020 dalanicolai wrote:
> > I do not fully understand what you are referring to with 'more
> > complete and consistent, but  the functions I've sent in the
> > request are really small, only 5 lines, and I think they implement
> > the essence of doc-view its scrolling feature. It was really meant
> > as just a small extra convenient addition to solve the small, but
> > inconvenient problem, as explained in the original request.
>
> I have updated djvu.el on GNU Elpa, please take a look.
> I implemented commands for scrolling for the `Read' buffer both in
> regular (text) mode and image minor mode.  Also, I adopted the
> keybindings from doc-view and added a user option djvu-continuous
> similar to doc-view-continuous.  So likely you may want to customize
> djvu-continuous.
>
> Please, let me know if this works for you, then I can close this bug
> report.
>
> > Well, in the djvu2.el package, I use the info in the annotation
> > buffer to draw the annotations (using imagemagick its convert
> > command). Of course as just a plain reader (without annotation
> > features), doc-view is already a fine reader for djvu documents.
>
> You do not need imagemagick convert for this.  For the ppm images
> used by djvu.el, emacs can do that, too, see `djvu-image-rect'.
> Maybe I'll do that one day.
>
> However, adding just the color of the annotations I find less
> important than also displaying tooltips.  These tooltips are
> displayed in the regular text mode of the Read buffers.  I do not
> know how to generate tooltips based on the pixel coordinates of the
> mouse pointer over an image.
>